<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfConcelhosERP ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfConcelhosERP
 * @subpackage Arrays
 */
class ArrayOfConcelhosERP extends AbstractStructArrayBase
{
    /**
     * The ConcelhosERP
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ConcelhosERP[]
     */
    public $ConcelhosERP;
    /**
     * Constructor method for ArrayOfConcelhosERP
     * @uses ArrayOfConcelhosERP::setConcelhosERP()
     * @param \StructType\ConcelhosERP[] $concelhosERP
     */
    public function __construct(array $concelhosERP = array())
    {
        $this
            ->setConcelhosERP($concelhosERP);
    }
    /**
     * Get ConcelhosERP value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ConcelhosERP[]|null
     */
    public function getConcelhosERP()
    {
        return isset($this->ConcelhosERP) ? $this->ConcelhosERP : null;
    }
    /**
     * Set ConcelhosERP value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ConcelhosERP[] $concelhosERP
     * @return \ArrayType\ArrayOfConcelhosERP
     */
    public function setConcelhosERP(array $concelhosERP = array())
    {
        foreach ($concelhosERP as $arrayOfConcelhosERPConcelhosERPItem) {
            // validation for constraint: itemType
            if (!$arrayOfConcelhosERPConcelhosERPItem instanceof \StructType\ConcelhosERP) {
                throw new \InvalidArgumentException(sprintf('The ConcelhosERP property can only contain items of \StructType\ConcelhosERP, "%s" given', is_object($arrayOfConcelhosERPConcelhosERPItem) ? get_class($arrayOfConcelhosERPConcelhosERPItem) : gettype($arrayOfConcelhosERPConcelhosERPItem)), __LINE__);
            }
        }
        if (is_null($concelhosERP) || (is_array($concelhosERP) && empty($concelhosERP))) {
            unset($this->ConcelhosERP);
        } else {
            $this->ConcelhosERP = $concelhosERP;
        }
        return $this;
    }
    /**
     * Add item to ConcelhosERP value
     * @throws \InvalidArgumentException
     * @param \StructType\ConcelhosERP $item
     * @return \ArrayType\ArrayOfConcelhosERP
     */
    public function addToConcelhosERP(\StructType\ConcelhosERP $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ConcelhosERP) {
            throw new \InvalidArgumentException(sprintf('The ConcelhosERP property can only contain items of \StructType\ConcelhosERP, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ConcelhosERP[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ConcelhosERP|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ConcelhosERP|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ConcelhosERP|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ConcelhosERP|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ConcelhosERP|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ConcelhosERP
     */
    public function getAttributeName()
    {
        return 'ConcelhosERP';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfConcelhosERP
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
